#ifndef OUTILS_H
#define OUTILS_H


#include <iostream>
#include <sstream>
//#include "barycentre.h"
//#include "graphe.h"


namespace MRFSegm {

// to deal with type names
#include "macros_avant.h"

// divers outils, manipulation/sauvegarde de fichiers surtout

void verifier(string& output);
void verifier_non_existence(string& output);


// pour sauver/relire des vecteurs/matrices int/double en binaire
// (vieux truc)
/*
template <class T>
void sauve_binaire(RecImage<T> A, string nom){
  
  ofstream f(nom.c_str(), ios::out | ios::binary);
  if (!f.is_open()) cout << "Erreur ouverture " << nom.c_str() << endl;
  f.write( (char*)(&(A.nx)), sizeof(int)); 
  f.write( (char*)(&(A.ny)), sizeof(int)); 

  for (int i = 0; i<A.nx; i++)
    for (int j = 0; j<A.ny; j++)
      f.write( (char*) (&(A(i,j))), sizeof(T) );
  f.close();
}

template <class T>
void lit_binaire(string nom, RecImage<T>& A){
  ifstream f(nom.c_str(), ios::in | ios::binary);
  if (!f.is_open()) cout << "Erreur ouverture " << nom.c_str() << endl;
  int nx, ny;
  f.read( (char*)(&nx), sizeof(int)); 
  f.read( (char*)(&ny), sizeof(int)); 
  A.alloue(nx, ny);

  for (int i = 0; i<nx; i++)
    for (int j = 0; j<ny; j++)
      f.read( (char*) (&(A(i,j))), sizeof(T) );
  f.close();

}
*/

// Ecriture generique de variables dans des fichiers
// attention au boolen...

ofstream* ouvre_eventuellement_fichier(string nom, bool deja_ouvert, ofstream* f, bool binaire = true){
  if (deja_ouvert)
    return f;
  else {
    verifier_non_existence(nom);
    ofstream* g = new ofstream;
    if (binaire)
      (*g).open(nom.c_str(), ios::out | ios::binary);
    else
      (*g).open(nom.c_str(), ios::out);

    if (!(*g).is_open()) cout << "Erreur ouverture " << nom.c_str() << endl;
    return g;
  }  
}

void ferme_eventuellement_fichier(bool deja_ouvert, ofstream*& f){
  if (! deja_ouvert){
    (*f).close();
    delete f;
  }
}

template <class T>
void sauve_binaire(const T& a, string nom, bool binaire = true, bool deja_ouvert = false, ofstream* f = NULL){

  string typ = chaine_type(T);
  if ( (typ!="string")&&(typ!="double")&&(typ!="int")&&(typ!="bool") )
    cout << "Attention, la sauvegarde va probablement planter, type non standard." << endl;

  ofstream* g = ouvre_eventuellement_fichier(nom, deja_ouvert, f, binaire);
  if (binaire)
    (*g).write( (char*)(&a), sizeof(T)); 
  else
    (*g) << a << endl;

  ferme_eventuellement_fichier(deja_ouvert, g);
}


template <class T>
void sauve_binaire(const vector<T>& A, string nom, bool binaire = true, bool deja_ouvert = false, ofstream* f = NULL){
  //  cout << "Sauv vect" << endl;
  ofstream* g = ouvre_eventuellement_fichier(nom, deja_ouvert, f, binaire);

  int n = A.size();
  sauve_binaire(n, nom, binaire, true, g);

  for (int i = 0; i<n; i++)
    sauve_binaire(A[i], nom, binaire, true, g);

  //).write( (char*) (&(A(i))), sizeof(T) );

  ferme_eventuellement_fichier(deja_ouvert, g);
}


template <class T>
void sauve_binaire(const RecImage<T>& A, string nom, bool binaire = true, bool deja_ouvert = false, ofstream* f = NULL){
  ofstream* g = ouvre_eventuellement_fichier(nom, deja_ouvert, f, binaire);

  sauve_binaire(A.nx, nom, binaire, true, g);
  sauve_binaire(A.ny, nom, binaire, true, g);

  for (int i = 0; i<A.nx; i++)
    for (int j = 0; j<A.ny; j++)
      sauve_binaire(A(i,j), nom, binaire, true, g);

  ferme_eventuellement_fichier(deja_ouvert, g);
}


template <class T>
void sauve_binaire(const Volume<T>& A, string nom, bool binaire = true, bool deja_ouvert = false, ofstream* f = NULL){
  ofstream* g = ouvre_eventuellement_fichier(nom, deja_ouvert, f, binaire);

  sauve_binaire(A.nx, nom, binaire, true, g);
  sauve_binaire(A.ny, nom, binaire, true, g);
  sauve_binaire(A.nz, nom, binaire, true, g);

  for (int i = 0; i<A.nx; i++)
    for (int j = 0; j<A.ny; j++)
      for (int k = 0; k<A.nz; k++)
	sauve_binaire(A(i,j,k), nom, binaire, true, g);

  ferme_eventuellement_fichier(deja_ouvert, g);
}


/* template<> */
/* void sauve_binaire(const IPoint& a, string nom, bool binaire, bool deja_ouvert, ofstream* f){ */
/*   ofstream* g = ouvre_eventuellement_fichier(nom, deja_ouvert, f, binaire); */
/*   sauve_binaire(a.x, nom, binaire, true, g); */
/*   sauve_binaire(a.y, nom, binaire, true, g); */
/*   ferme_eventuellement_fichier(deja_ouvert, g); */
/* } */

/* template<> */
/* void sauve_binaire(const DPoint& a, string nom, bool binaire, bool deja_ouvert, ofstream* f){ */
/*   ofstream* g = ouvre_eventuellement_fichier(nom, deja_ouvert, f, binaire); */
/*   sauve_binaire(a.x, nom, binaire, true, g); */
/*   sauve_binaire(a.y, nom, binaire, true, g); */
/*   ferme_eventuellement_fichier(deja_ouvert, g); */
/* } */

/* template <class T> */
/* void sauve_binaire(const double_et<T>& A, string nom, bool binaire = true, bool deja_ouvert = false, ofstream* f = NULL){ */
/*   ofstream* g = ouvre_eventuellement_fichier(nom, deja_ouvert, f, binaire); */
/*   sauve_binaire(A.x, nom, binaire, true, g); */
/*   sauve_binaire(A.y, nom, binaire, true, g); */
/*   ferme_eventuellement_fichier(deja_ouvert, g); */
/* } */

template <class T, class U>
  void sauve_binaire(const T& A, const U& B, string nom, bool binaire = true, bool deja_ouvert = false, ofstream* f = NULL){
  ofstream* g = ouvre_eventuellement_fichier(nom, deja_ouvert, f, binaire);
  sauve_binaire(A, nom, binaire, true, g);
  sauve_binaire(B, nom, binaire, true, g);
  ferme_eventuellement_fichier(deja_ouvert, g);
}

/* template <class T, class U, class V> */
/*   void sauve_binaire(const Triplet<T,U,V>& A, string nom, bool binaire = true, bool deja_ouvert = false, ofstream* f = NULL){ */
/*   ofstream* g = ouvre_eventuellement_fichier(nom, deja_ouvert, f, binaire); */
/*   sauve_binaire(A.x, nom, binaire, true, g); */
/*   sauve_binaire(A.y, nom, binaire, true, g); */
/*   sauve_binaire(A.z, nom, binaire, true, g); */
/*   ferme_eventuellement_fichier(deja_ouvert, g); */
/* } */

template <class T, class U, class V>
  void sauve_binaire(const T& A, const U& B, const V& C, string nom, bool binaire = true, bool deja_ouvert = false, ofstream* f = NULL){
  ofstream* g = ouvre_eventuellement_fichier(nom, deja_ouvert, f, binaire);
  sauve_binaire(A, nom, binaire, true, g);
  sauve_binaire(B, nom, binaire, true, g);
  sauve_binaire(C, nom, binaire, true, g);
  ferme_eventuellement_fichier(deja_ouvert, g);
}

template <class T, class U, class V, class W>
  void sauve_binaire(const T& A, const U& B, const V& C, const W& D, string nom, bool binaire = true, bool deja_ouvert = false, ofstream* f = NULL){
  ofstream* g = ouvre_eventuellement_fichier(nom, deja_ouvert, f, binaire);
  sauve_binaire(A, B, C, nom, binaire, true, g);
  sauve_binaire(D, nom, binaire, true, g);
  ferme_eventuellement_fichier(deja_ouvert, g);
}

template <class T, class U, class V, class W, class X>
  void sauve_binaire(const T& A, const U& B, const V& C, const W& D, const X& E, string nom, bool binaire = true, bool deja_ouvert = false, ofstream* f = NULL){
  ofstream* g = ouvre_eventuellement_fichier(nom, deja_ouvert, f, binaire);
  sauve_binaire(A, B, C, D, nom, binaire, true, g);
  sauve_binaire(E, nom, binaire, true, g);
  ferme_eventuellement_fichier(deja_ouvert, g);
}

template <class T, class U, class V, class W, class X, class Y>
  void sauve_binaire(const T& A, const U& B, const V& C, const W& D, const X& E, const Y& F, string nom, bool binaire = true, bool deja_ouvert = false, ofstream* f = NULL){
  ofstream* g = ouvre_eventuellement_fichier(nom, deja_ouvert, f, binaire);
  sauve_binaire(A, B, C, D, E, nom, binaire, true, g);
  sauve_binaire(F, nom, binaire, true, g);
  ferme_eventuellement_fichier(deja_ouvert, g);
}

template <class T, class U, class V, class W, class X, class Y, class Z>
  void sauve_binaire(const T& A, const U& B, const V& C, const W& D, const X& E, const Y& F, const Z& G, string nom, bool binaire = true, bool deja_ouvert = false, ofstream* f = NULL){
  ofstream* g = ouvre_eventuellement_fichier(nom, deja_ouvert, f, binaire);
  sauve_binaire(A, B, C, D, E, F, nom, binaire, true, g);
  sauve_binaire(G, nom, binaire, true, g);
  ferme_eventuellement_fichier(deja_ouvert, g);
}






// lecture gnrique

ifstream* ouvre_eventuellement_fichier(string nom, bool deja_ouvert, ifstream* f, bool binaire = true){
  if (deja_ouvert)
    return f;
  else {
    ifstream* g = new ifstream;
    if (binaire)
      (*g).open(nom.c_str(), ios::in | ios::binary);
    else
      (*g).open(nom.c_str(), ios::in);

    if (!(*g).is_open()) cout << "Erreur ouverture lecture " << nom.c_str() << endl;
    return g;
  }  
}

void ferme_eventuellement_fichier(bool deja_ouvert, ifstream*& f){
  if (! deja_ouvert){
    (*f).close();
    delete f;
  }
}



template <class T>
void lit_binaire(T& a, string nom, bool binaire = true, bool deja_ouvert = false, ifstream* f = NULL){

  string typ = chaine_type(T);
  if ( (typ!="string")&&(typ!="double")&&(typ!="int")&&(typ!="bool") )
    cout << "Attention, la lecture va probablement planter, type non standard." << endl;

  ifstream* g = ouvre_eventuellement_fichier(nom, deja_ouvert, f, binaire);
  if (binaire)
    (*g).read( (char*) (&a), sizeof(T));
  else
    (*g) >> a;

  ferme_eventuellement_fichier(deja_ouvert, g);
}


template <class T>
void lit_binaire(vector<T>& A, string nom, bool binaire = true, bool deja_ouvert = false, ifstream* f = NULL){

  ifstream* g = ouvre_eventuellement_fichier(nom, deja_ouvert, f, binaire);

  int n;
  lit_binaire(n, nom, binaire, true, g);
  A.resize(n);

  for (int i = 0; i<n; i++)
    lit_binaire(A[i], nom, binaire, true, g);

  ferme_eventuellement_fichier(deja_ouvert, g);
}


template <class T>
void lit_binaire(RecImage<T>& A, string nom, bool binaire = true, bool deja_ouvert = false, ifstream* f = NULL){

  ifstream* g = ouvre_eventuellement_fichier(nom, deja_ouvert, f, binaire);

  int nx, ny;
  lit_binaire(nx, nom, binaire, true, g);
  lit_binaire(ny, nom, binaire, true, g);
  A.alloue(nx, ny);

  for (int i = 0; i<A.nx; i++)
    for (int j = 0; j<A.ny; j++)
      lit_binaire(A(i,j), nom, binaire, true, g);

  ferme_eventuellement_fichier(deja_ouvert, g);
}



template <class T>
void lit_binaire(Volume<T>& A, string nom, bool binaire = true, bool deja_ouvert = false, ifstream* f = NULL){

  ifstream* g = ouvre_eventuellement_fichier(nom, deja_ouvert, f, binaire);

  int nx, ny, nz;
  lit_binaire(nx, nom, binaire, true, g);
  lit_binaire(ny, nom, binaire, true, g);
  lit_binaire(nz, nom, binaire, true, g);
  A.allocate(nx, ny, nz);

  for (int i = 0; i<A.nx; i++)
    for (int j = 0; j<A.ny; j++)
      for (int k = 0; k<A.nz; k++)
	lit_binaire(A(i,j,k), nom, binaire, true, g);

  ferme_eventuellement_fichier(deja_ouvert, g);
 }


/* template<> */
/* void lit_binaire(IPoint& a, string nom, bool binaire, bool deja_ouvert, ifstream* f){ */
/*   ifstream* g = ouvre_eventuellement_fichier(nom, deja_ouvert, f, binaire); */
/*   lit_binaire(a.x, nom, binaire, true, g); */
/*   lit_binaire(a.y, nom, binaire, true, g); */
/*   ferme_eventuellement_fichier(deja_ouvert, g); */
/* } */

/* template<> */
/* void lit_binaire(DPoint& a, string nom, bool binaire, bool deja_ouvert, ifstream* f){ */
/*   ifstream* g = ouvre_eventuellement_fichier(nom, deja_ouvert, f, binaire); */
/*   lit_binaire(a.x, nom, binaire, true, g); */
/*   lit_binaire(a.y, nom, binaire, true, g); */
/*   ferme_eventuellement_fichier(deja_ouvert, g); */
/* } */

/* template <class T> */
/* void lit_binaire(double_et<T>& A, string nom, bool binaire = true, bool deja_ouvert = false, ifstream* f = NULL){ */
/*   ifstream* g = ouvre_eventuellement_fichier(nom, deja_ouvert, f, binaire); */
/*   lit_binaire(A.x, nom, binaire, true, g); */
/*   lit_binaire(A.y, nom, binaire, true, g); */
/*   ferme_eventuellement_fichier(deja_ouvert, g); */
/* } */

template <class T, class U>
void lit_binaire(T& A, U& B, string nom, bool binaire = true, bool deja_ouvert = false, ifstream* f = NULL){
  ifstream* g = ouvre_eventuellement_fichier(nom, deja_ouvert, f, binaire);
  lit_binaire(A, nom, binaire, true, g);
  lit_binaire(B, nom, binaire, true, g);
  ferme_eventuellement_fichier(deja_ouvert, g);
}

/* template <class T, class U, class V> */
/*   void lit_binaire(Triplet<T,U,V>& A, string nom, bool binaire = true, bool deja_ouvert = false, ifstream* f = NULL){ */
/*   ifstream* g = ouvre_eventuellement_fichier(nom, deja_ouvert, f, binaire); */
/*   lit_binaire(A.x, nom, binaire, true, g); */
/*   lit_binaire(A.y, nom, binaire, true, g); */
/*   lit_binaire(A.z, nom, binaire, true, g); */
/*   ferme_eventuellement_fichier(deja_ouvert, g); */
/* } */

template <class T, class U, class V>
  void lit_binaire(T& A, U& B, V& C, string nom, bool binaire = true, bool deja_ouvert = false, ifstream* f = NULL){
  ifstream* g = ouvre_eventuellement_fichier(nom, deja_ouvert, f, binaire);
  lit_binaire(A, nom, binaire, true, g);
  lit_binaire(B, nom, binaire, true, g);
  lit_binaire(C, nom, binaire, true, g);
  ferme_eventuellement_fichier(deja_ouvert, g);
}


template <class T, class U, class V, class W>
  void lit_binaire(T& A, U& B, V& C, W& D, string nom, bool binaire = true, bool deja_ouvert = false, ifstream* f = NULL){
  ifstream* g = ouvre_eventuellement_fichier(nom, deja_ouvert, f, binaire);
  lit_binaire(A, B, C, nom, binaire, true, g);
  lit_binaire(D, nom, binaire, true, g);
  ferme_eventuellement_fichier(deja_ouvert, g);
}

template <class T, class U, class V, class W, class X>
  void lit_binaire(T& A, U& B, V& C, W& D, X& E, string nom, bool binaire = true, bool deja_ouvert = false, ifstream* f = NULL){
  ifstream* g = ouvre_eventuellement_fichier(nom, deja_ouvert, f, binaire);
  lit_binaire(A, B, C, D, nom, binaire, true, g);
  lit_binaire(E, nom, binaire, true, g);
  ferme_eventuellement_fichier(deja_ouvert, g);
}

template <class T, class U, class V, class W, class X, class Y>
  void lit_binaire(T& A, U& B, V& C, W& D, X& E, Y& F, string nom, bool binaire = true, bool deja_ouvert = false, ifstream* f = NULL){
  ifstream* g = ouvre_eventuellement_fichier(nom, deja_ouvert, f, binaire);
  lit_binaire(A, B, C, D, E, nom, binaire, true, g);
  lit_binaire(F, nom, binaire, true, g);
  ferme_eventuellement_fichier(deja_ouvert, g);
}

template <class T, class U, class V, class W, class X, class Y, class Z>
  void lit_binaire(T& A, U& B, V& C, W& D, X& E, Y& F, Z& G, string nom, bool binaire = true, bool deja_ouvert = false, ifstream* f = NULL){
  ifstream* g = ouvre_eventuellement_fichier(nom, deja_ouvert, f, binaire);
  lit_binaire(A, B, C, D, E, F, nom, binaire, true, g);
  lit_binaire(G, nom, binaire, true, g);
  ferme_eventuellement_fichier(deja_ouvert, g);
}




/* // sauver les parametres  */
/* template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11, class T12, class T13, class T14, class T15, class T16, class T17, class T18, class T19, class T20, class T21, class T22, class T23, class T24> */
/*   void sauve_param(string nom_fic, T1* a1, char* na1, T2* a2, char* na2, T3* a3, char* na3, T4* a4, char* na4, T5* a5, char* na5, T6* a6, char* na6, T7* a7, char* na7, T8* a8, char* na8, T9* a9, char* na9, T10* a10, char* na10, T11* a11, char* na11, T12* a12, char* na12, T13* a13, char* na13, T14* a14, char* na14, T15* a15, char* na15, T16* a16, char* na16, T17* a17, char* na17, T18* a18, char* na18, T19* a19, char* na19, T20* a20, char* na20, T21* a21, char* na21, T22* a22, char* na22, T23* a23, char* na23, T24* a24, char* na24){ */


/*   ofstream fic_param(nom_fic.c_str()); */
/*   if (a1 != NULL) */
/*     fic_param << na1 << " : " <<  *a1 << endl; */
/*   if (a2 != NULL) */
/*     fic_param << na2 << " : " <<  *a2 << endl; */
/*   if (a3 != NULL) */
/*     fic_param << na3 << " : " <<  *a3 << endl; */
/*   if (a4 != NULL) */
/*     fic_param << na4 << " : " <<  *a4 << endl; */
/*   if (a5 != NULL) */
/*     fic_param << na5 << " : " <<  *a5 << endl; */
/*   if (a6 != NULL) */
/*     fic_param << na6 << " : " <<  *a6 << endl; */
/*   if (a7 != NULL) */
/*     fic_param << na7 << " : " <<  *a7 << endl; */
/*   if (a8 != NULL) */
/*     fic_param << na8 << " : " <<  *a8 << endl; */
/*   if (a9 != NULL) */
/*     fic_param << na9 << " : " <<  *a9 << endl; */
/*   if (a10 != NULL) */
/*     fic_param << na10 << " : " <<  *a10 << endl; */
/*   if (a11 != NULL) */
/*     fic_param << na11 << " : " <<  *a11 << endl; */
/*   if (a12 != NULL) */
/*     fic_param << na12 << " : " <<  *a12 << endl; */
/*   if (a13 != NULL) */
/*     fic_param << na13 << " : " <<  *a13 << endl; */
/*   if (a14 != NULL) */
/*     fic_param << na14 << " : " <<  *a14 << endl; */
/*   if (a15 != NULL) */
/*     fic_param << na15 << " : " <<  *a15 << endl; */
/*   if (a16 != NULL) */
/*     fic_param << na16 << " : " <<  *a16 << endl; */
/*   if (a17 != NULL) */
/*     fic_param << na17 << " : " <<  *a17 << endl; */
/*   if (a18 != NULL) */
/*     fic_param << na18 << " : " <<  *a18 << endl; */
/*   if (a19 != NULL) */
/*     fic_param << na19 << " : " <<  *a19 << endl; */
/*   if (a20 != NULL) */
/*     fic_param << na20 << " : " <<  *a20 << endl; */
/*   if (a21 != NULL) */
/*     fic_param << na21 << " : " <<  *a21 << endl; */
/*   if (a22 != NULL) */
/*     fic_param << na22 << " : " <<  *a22 << endl; */
/*   if (a23 != NULL) */
/*     fic_param << na23 << " : " <<  *a23 << endl; */
/*   if (a24 != NULL) */
/*     fic_param << na24 << " : " <<  *a24 << endl; */
/*   fic_param.close(); */

/* } */

/* template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11, class T12, class T13, class T14, class T15, class T16, class T17, class T18, class T19, class T20, class T21, class T22, class T23> */
/*   void sauve_param(string nom_fic, T1* a1, char* na1, T2* a2, char* na2, T3* a3, char* na3, T4* a4, char* na4, T5* a5, char* na5, T6* a6, char* na6, T7* a7, char* na7, T8* a8, char* na8, T9* a9, char* na9, T10* a10, char* na10, T11* a11, char* na11, T12* a12, char* na12, T13* a13, char* na13, T14* a14, char* na14, T15* a15, char* na15, T16* a16, char* na16, T17* a17, char* na17, T18* a18, char* na18, T19* a19, char* na19, T20* a20, char* na20, T21* a21, char* na21, T22* a22, char* na22, T23* a23, char* na23){ */
/*   sauve_param(nom_fic, a1, na1, a2, na2, a3, na3, a4, na4, a5, na5, a6, na6, a7, na7, a8, na8, a9, na9, a10, na10, a11, na11, a12, na12, a13, na13, a14, na14, a15, na15, a16, na16, a17, na17, a18, na18, a19, na19, a20, na20, a21, na21, a22, na22, a23, na23, (double*)NULL, NULL); */
/* } */

/* template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11, class T12, class T13, class T14, class T15, class T16, class T17, class T18, class T19, class T20, class T21, class T22> */
/*   void sauve_param(string nom_fic, T1* a1, char* na1, T2* a2, char* na2, T3* a3, char* na3, T4* a4, char* na4, T5* a5, char* na5, T6* a6, char* na6, T7* a7, char* na7, T8* a8, char* na8, T9* a9, char* na9, T10* a10, char* na10, T11* a11, char* na11, T12* a12, char* na12, T13* a13, char* na13, T14* a14, char* na14, T15* a15, char* na15, T16* a16, char* na16, T17* a17, char* na17, T18* a18, char* na18, T19* a19, char* na19, T20* a20, char* na20, T21* a21, char* na21, T22* a22, char* na22){ */
/*   sauve_param(nom_fic, a1, na1, a2, na2, a3, na3, a4, na4, a5, na5, a6, na6, a7, na7, a8, na8, a9, na9, a10, na10, a11, na11, a12, na12, a13, na13, a14, na14, a15, na15, a16, na16, a17, na17, a18, na18, a19, na19, a20, na20, a21, na21, a22, na22, (double*)NULL, NULL); */
/* } */

/* template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11, class T12, class T13, class T14, class T15, class T16, class T17, class T18, class T19, class T20, class T21> */
/*   void sauve_param(string nom_fic, T1* a1, char* na1, T2* a2, char* na2, T3* a3, char* na3, T4* a4, char* na4, T5* a5, char* na5, T6* a6, char* na6, T7* a7, char* na7, T8* a8, char* na8, T9* a9, char* na9, T10* a10, char* na10, T11* a11, char* na11, T12* a12, char* na12, T13* a13, char* na13, T14* a14, char* na14, T15* a15, char* na15, T16* a16, char* na16, T17* a17, char* na17, T18* a18, char* na18, T19* a19, char* na19, T20* a20, char* na20, T21* a21, char* na21){ */
/*   sauve_param(nom_fic, a1, na1, a2, na2, a3, na3, a4, na4, a5, na5, a6, na6, a7, na7, a8, na8, a9, na9, a10, na10, a11, na11, a12, na12, a13, na13, a14, na14, a15, na15, a16, na16, a17, na17, a18, na18, a19, na19, a20, na20, a21, na21, (double*)NULL, NULL); */
/* } */

/* template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11, class T12, class T13, class T14, class T15, class T16, class T17, class T18, class T19, class T20> */
/*   void sauve_param(string nom_fic, T1* a1, char* na1, T2* a2, char* na2, T3* a3, char* na3, T4* a4, char* na4, T5* a5, char* na5, T6* a6, char* na6, T7* a7, char* na7, T8* a8, char* na8, T9* a9, char* na9, T10* a10, char* na10, T11* a11, char* na11, T12* a12, char* na12, T13* a13, char* na13, T14* a14, char* na14, T15* a15, char* na15, T16* a16, char* na16, T17* a17, char* na17, T18* a18, char* na18, T19* a19, char* na19, T20* a20, char* na20){ */
/*   sauve_param(nom_fic, a1, na1, a2, na2, a3, na3, a4, na4, a5, na5, a6, na6, a7, na7, a8, na8, a9, na9, a10, na10, a11, na11, a12, na12, a13, na13, a14, na14, a15, na15, a16, na16, a17, na17, a18, na18, a19, na19, a20, na20, (double*)NULL, NULL); */
/* } */

/* template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11, class T12, class T13, class T14, class T15, class T16, class T17, class T18, class T19> */
/*   void sauve_param(string nom_fic, T1* a1, char* na1, T2* a2, char* na2, T3* a3, char* na3, T4* a4, char* na4, T5* a5, char* na5, T6* a6, char* na6, T7* a7, char* na7, T8* a8, char* na8, T9* a9, char* na9, T10* a10, char* na10, T11* a11, char* na11, T12* a12, char* na12, T13* a13, char* na13, T14* a14, char* na14, T15* a15, char* na15, T16* a16, char* na16, T17* a17, char* na17, T18* a18, char* na18, T19* a19, char* na19){ */
/*   sauve_param(nom_fic, a1, na1, a2, na2, a3, na3, a4, na4, a5, na5, a6, na6, a7, na7, a8, na8, a9, na9, a10, na10, a11, na11, a12, na12, a13, na13, a14, na14, a15, na15, a16, na16, a17, na17, a18, na18, a19, na19, (double*)NULL, NULL); */
/* } */

/* template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11, class T12, class T13, class T14, class T15, class T16, class T17, class T18> */
/*   void sauve_param(string nom_fic, T1* a1, char* na1, T2* a2, char* na2, T3* a3, char* na3, T4* a4, char* na4, T5* a5, char* na5, T6* a6, char* na6, T7* a7, char* na7, T8* a8, char* na8, T9* a9, char* na9, T10* a10, char* na10, T11* a11, char* na11, T12* a12, char* na12, T13* a13, char* na13, T14* a14, char* na14, T15* a15, char* na15, T16* a16, char* na16, T17* a17, char* na17, T18* a18, char* na18){ */
/*   sauve_param(nom_fic, a1, na1, a2, na2, a3, na3, a4, na4, a5, na5, a6, na6, a7, na7, a8, na8, a9, na9, a10, na10, a11, na11, a12, na12, a13, na13, a14, na14, a15, na15, a16, na16, a17, na17, a18, na18, (double*)NULL, NULL); */
/* } */

/* template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11, class T12, class T13, class T14, class T15, class T16, class T17> */
/*   void sauve_param(string nom_fic, T1* a1, char* na1, T2* a2, char* na2, T3* a3, char* na3, T4* a4, char* na4, T5* a5, char* na5, T6* a6, char* na6, T7* a7, char* na7, T8* a8, char* na8, T9* a9, char* na9, T10* a10, char* na10, T11* a11, char* na11, T12* a12, char* na12, T13* a13, char* na13, T14* a14, char* na14, T15* a15, char* na15, T16* a16, char* na16, T17* a17, char* na17){ */
/*   sauve_param(nom_fic, a1, na1, a2, na2, a3, na3, a4, na4, a5, na5, a6, na6, a7, na7, a8, na8, a9, na9, a10, na10, a11, na11, a12, na12, a13, na13, a14, na14, a15, na15, a16, na16, a17, na17, (double*)NULL, NULL); */
/* } */

/* template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11, class T12, class T13, class T14, class T15, class T16> */
/*   void sauve_param(string nom_fic, T1* a1, char* na1, T2* a2, char* na2, T3* a3, char* na3, T4* a4, char* na4, T5* a5, char* na5, T6* a6, char* na6, T7* a7, char* na7, T8* a8, char* na8, T9* a9, char* na9, T10* a10, char* na10, T11* a11, char* na11, T12* a12, char* na12, T13* a13, char* na13, T14* a14, char* na14, T15* a15, char* na15, T16* a16, char* na16){ */
/*   sauve_param(nom_fic, a1, na1, a2, na2, a3, na3, a4, na4, a5, na5, a6, na6, a7, na7, a8, na8, a9, na9, a10, na10, a11, na11, a12, na12, a13, na13, a14, na14, a15, na15, a16, na16, (double*)NULL, NULL); */
/* } */

/* template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11, class T12, class T13, class T14, class T15> */
/*  void sauve_param(string nom_fic, T1* a1, char* na1, T2* a2, char* na2, T3* a3, char* na3, T4* a4, char* na4, T5* a5, char* na5, T6* a6, char* na6, T7* a7, char* na7, T8* a8, char* na8, T9* a9, char* na9, T10* a10, char* na10, T11* a11, char* na11, T12* a12, char* na12, T13* a13, char* na13, T14* a14, char* na14, T15* a15, char* na15){ */
/*   sauve_param(nom_fic, a1, na1, a2, na2, a3, na3, a4, na4, a5, na5, a6, na6, a7, na7, a8, na8, a9, na9, a10, na10, a11, na11, a12, na12, a13, na13, a14, na14, a15, na15, (double*)NULL, NULL); */
/* } */

/* template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11, class T12, class T13, class T14> */
/*  void sauve_param(string nom_fic, T1* a1, char* na1, T2* a2, char* na2, T3* a3, char* na3, T4* a4, char* na4, T5* a5, char* na5, T6* a6, char* na6, T7* a7, char* na7, T8* a8, char* na8, T9* a9, char* na9, T10* a10, char* na10, T11* a11, char* na11, T12* a12, char* na12, T13* a13, char* na13, T14* a14, char* na14){ */
/*   sauve_param(nom_fic, a1, na1, a2, na2, a3, na3, a4, na4, a5, na5, a6, na6, a7, na7, a8, na8, a9, na9, a10, na10, a11, na11, a12, na12, a13, na13, a14, na14, (double*)NULL, NULL); */
/* } */

/* template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11, class T12, class T13> */
/*  void sauve_param(string nom_fic, T1* a1, char* na1, T2* a2, char* na2, T3* a3, char* na3, T4* a4, char* na4, T5* a5, char* na5, T6* a6, char* na6, T7* a7, char* na7, T8* a8, char* na8, T9* a9, char* na9, T10* a10, char* na10, T11* a11, char* na11, T12* a12, char* na12, T13* a13, char* na13){ */
/*   sauve_param(nom_fic, a1, na1, a2, na2, a3, na3, a4, na4, a5, na5, a6, na6, a7, na7, a8, na8, a9, na9, a10, na10, a11, na11, a12, na12, a13, na13, (double*)NULL, NULL); */
/* } */

/* template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11, class T12> */
/*  void sauve_param(string nom_fic, T1* a1, char* na1, T2* a2, char* na2, T3* a3, char* na3, T4* a4, char* na4, T5* a5, char* na5, T6* a6, char* na6, T7* a7, char* na7, T8* a8, char* na8, T9* a9, char* na9, T10* a10, char* na10, T11* a11, char* na11, T12* a12, char* na12){ */
/*   sauve_param(nom_fic, a1, na1, a2, na2, a3, na3, a4, na4, a5, na5, a6, na6, a7, na7, a8, na8, a9, na9, a10, na10, a11, na11, a12, na12, (double*)NULL, NULL); */
/* } */

/* template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11> */
/*  void sauve_param(string nom_fic, T1* a1, char* na1, T2* a2, char* na2, T3* a3, char* na3, T4* a4, char* na4, T5* a5, char* na5, T6* a6, char* na6, T7* a7, char* na7, T8* a8, char* na8, T9* a9, char* na9, T10* a10, char* na10, T11* a11, char* na11){ */
/*   sauve_param(nom_fic, a1, na1, a2, na2, a3, na3, a4, na4, a5, na5, a6, na6, a7, na7, a8, na8, a9, na9, a10, na10, a11, na11, (double*)NULL, NULL); */
/* } */


/* template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10> */
/*  void sauve_param(string nom_fic, T1* a1, char* na1, T2* a2, char* na2, T3* a3, char* na3, T4* a4, char* na4, T5* a5, char* na5, T6* a6, char* na6, T7* a7, char* na7, T8* a8, char* na8, T9* a9, char* na9, T10* a10, char* na10){ */
/*   sauve_param(nom_fic, a1, na1, a2, na2, a3, na3, a4, na4, a5, na5, a6, na6, a7, na7, a8, na8, a9, na9, a10, na10, (double*)NULL, NULL); */
/* } */


/* template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9> */
/*  void sauve_param(string nom_fic, T1* a1, char* na1, T2* a2, char* na2, T3* a3, char* na3, T4* a4, char* na4, T5* a5, char* na5, T6* a6, char* na6, T7* a7, char* na7, T8* a8, char* na8, T9* a9, char* na9){ */
/*   sauve_param(nom_fic, a1, na1, a2, na2, a3, na3, a4, na4, a5, na5, a6, na6, a7, na7, a8, na8, a9, na9, (double*)NULL, NULL); */
/* } */


/* template<class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8> */
/*  void sauve_param(string nom_fic, T1* a1, char* na1, T2* a2, char* na2, T3* a3, char* na3, T4* a4, char* na4, T5* a5, char* na5, T6* a6, char* na6, T7* a7, char* na7, T8* a8, char* na8){ */
/*   sauve_param(nom_fic, a1, na1, a2, na2, a3, na3, a4, na4, a5, na5, a6, na6, a7, na7, a8, na8, (double*)NULL, NULL); */
/* } */


/* template<class T1, class T2, class T3, class T4, class T5, class T6, class T7> */
/*  void sauve_param(string nom_fic, T1* a1, char* na1, T2* a2, char* na2, T3* a3, char* na3, T4* a4, char* na4, T5* a5, char* na5, T6* a6, char* na6, T7* a7, char* na7){ */
/*   sauve_param(nom_fic, a1, na1, a2, na2, a3, na3, a4, na4, a5, na5, a6, na6, a7, na7, (double*)NULL, NULL); */
/* } */

/* template<class T1, class T2, class T3, class T4, class T5, class T6> */
/*  void sauve_param(string nom_fic, T1* a1, char* na1, T2* a2, char* na2, T3* a3, char* na3, T4* a4, char* na4, T5* a5, char* na5, T6* a6, char* na6){ */
/*   sauve_param(nom_fic, a1, na1, a2, na2, a3, na3, a4, na4, a5, na5, a6, na6, (double*)NULL, NULL); */
/* } */


/* template<class T1, class T2, class T3, class T4, class T5> */
/*  void sauve_param(string nom_fic, T1* a1, char* na1, T2* a2, char* na2, T3* a3, char* na3, T4* a4, char* na4, T5* a5, char* na5){ */
/*   sauve_param(nom_fic, a1, na1, a2, na2, a3, na3, a4, na4, a5, na5, (double*)NULL, NULL); */
/* } */


/* template<class T1, class T2, class T3, class T4> */
/*  void sauve_param(string nom_fic, T1* a1, char* na1, T2* a2, char* na2, T3* a3, char* na3, T4* a4, char* na4){ */
/*   sauve_param(nom_fic, a1, na1, a2, na2, a3, na3, a4, na4, (double*)NULL, NULL); */
/* } */


/* template<class T1, class T2, class T3> */
/*  void sauve_param(string nom_fic, T1* a1, char* na1, T2* a2, char* na2, T3* a3, char* na3){ */
/*   sauve_param(nom_fic, a1, na1, a2, na2, a3, na3, (double*)NULL, NULL); */
/* } */

/* template<class T1, class T2> */
/*  void sauve_param(string nom_fic, T1* a1, char* na1, T2* a2, char* na2){ */
/*   sauve_param(nom_fic, a1, na1, a2, na2, (double*)NULL, NULL); */
/* } */

/* template<class T1> */
/*  void sauve_param(string nom_fic, T1* a1, char* na1){ */
/*   sauve_param(nom_fic, a1, na1, (double*)NULL, NULL); */
/* } */


// vrifier qu'un fichier n'existe pas avant de l'craser
void verifier_et_changer(string& output){

  bool continuer = false;

  while (!continuer){
    string nom = output + "params.dat";
    ifstream fic_test;
    fic_test.open(nom.c_str());
    bool existedeja = fic_test.good();
    fic_test.close();

    nom = output + "proba.dat";
    ifstream fic_test2;
    fic_test2.open(nom.c_str());
    existedeja = (existedeja || fic_test2.good() );
    fic_test2.close();
    
    nom = output + "_taille.dat";
    ifstream fic_test3;
    fic_test3.open(nom.c_str());
    existedeja = (existedeja || fic_test3.good() );
    fic_test3.close();
    
    nom = output + ".dat";
    ifstream fic_test4;
    fic_test4.open(nom.c_str());
    existedeja = (existedeja || fic_test4.good() );
    fic_test4.close();

    if (existedeja){
      cout << '\a' << endl << "Attention, le fichier existe dj. Voulez-vous craser " << output << " ou taper un autre nom ? [defaut=ecraser, sinon taper le nom] : ";
      string reponse;
      getline(cin, reponse);
      if (reponse == "")
	continuer = true;
      else
	output = reponse;
      
    } else
      continuer = true;
  }  
}



void verifier(string& output){

  int nb_suff = 5;
  string* suffixes = new string[nb_suff];
  suffixes[0] = ".dat";
  suffixes[1] = ".pol";
  suffixes[2] = ".mng";
  suffixes[3] = ".mpg";
  suffixes[3] = "";
  

  bool continuer = false;

  while (!continuer){
    
    ifstream fic_test;
    fic_test.open(output.c_str());
    bool existedeja = fic_test.good();
    fic_test.close();

    
    for (int i = 0; i<nb_suff; i++){
      string nom = output + suffixes[i];
      ifstream fic_test2;
      fic_test2.open(nom.c_str());
      existedeja = (existedeja || fic_test2.good() );
      fic_test2.close();
    }

    if (existedeja){
      cout << '\a' << endl << "Attention, le fichier existe dj. Voulez-vous craser " << output << " ou taper un autre nom ? [defaut=ecraser, sinon taper le nom] : ";
      string reponse;
      getline(cin, reponse);
      if (reponse == "")
	continuer = true;
      else
	output = reponse;
      
    } else
      continuer = true;
  }  

  delete[] suffixes;

}



// verifie uniquement le nom donn et aucun autre
void verifier_non_existence(string& output){

  bool continuer = false;

  while (!continuer){
    
    ifstream fic_test;
    fic_test.open(output.c_str());
    bool existedeja = fic_test.good();
    fic_test.close();
    
    if (existedeja){
      cout << '\a' << endl << "Attention, le fichier existe dj. Voulez-vous craser " << output << " ou taper un autre nom ? [defaut=ecraser, sinon taper le nom] : ";
      string reponse;
      getline(cin, reponse);
      if (reponse == "")
	continuer = true;
      else
	output = reponse;
      
    } else
      continuer = true;
  }  
}


string vrai(bool a){
  if (a)
    return "oui";
  else
    return "non";
}


// pour lire les paramtres depuis... un fichier de paramtres !
// suppose qu'on ait dj ouvert le fichier de paramtres... et qu'on n'oublie pas de le fermer aprs
// Rgle d'usage : ne pas changer l'ordre des paramtres dans le fichier, un retour  la ligne = un nouveau paramtre
// Le nom du paramtre devant ":" n'a aucune influence
// Commentaires possibles : ligne commenant par //

template <class T>
void lire_param(ifstream& f, string nom_param, T& p){
  string aux; 
  bool commentaire = false;
  do {
    getline(f, aux);
    if (aux.substr(0,2) == "//"){
      cout << BoldRed << "Commentaire : " << TextMauve << aux.substr(2) << TextNormal << endl;
      commentaire = true;
    } else {
      commentaire = false;
    }
  }  while (commentaire);
  
  string::size_type ou_ca = aux.find(':', 0);
  if (ou_ca == string::npos){
    cout << '\a' << BoldGreen << "Hmm... Pb lecture de la ligne : " << TextGreen << aux << TextNormal << endl;
    return;
  }

  stringstream s; 
  s << aux.substr(ou_ca + 1);
  s >> p;
  cout << BoldGreen << nom_param << " : " << TextCyan << p << TextBlue << "            [ " << aux.substr(0, ou_ca-1) << " ] " << TextNormal << endl;
    
}

// cas spcial pour les boolens : vrai s'crit 1, et faux 0.
template <>
void lire_param(ifstream& f, string nom_param, bool& p){
  string aux; 
  bool commentaire = false;
  do {
    getline(f, aux);
    if (aux.substr(0,2) == "//"){
      cout << BoldRed << "Commentaire : " << TextMauve << aux.substr(2) << TextNormal << endl;
      commentaire = true;
    } else {
      commentaire = false;
    }
  }  while (commentaire);
  
  string::size_type ou_ca = aux.find(':', 0);
  if (ou_ca == string::npos){
    cout << '\a' << BoldGreen << "Hmm... Pb lecture de la ligne : " << TextGreen << aux << TextNormal << endl;
    return;
  }

  stringstream s; 
  s << aux.substr(ou_ca + 1);
  int i_aux;
  s >> i_aux;
  p = (i_aux == 1);
  cout << BoldGreen << nom_param << " : " << TextCyan << vrai(p) << TextBlue << "            [ " << aux.substr(0, ou_ca-1) << " ] " << TextNormal << endl;
}

// cas o on lit une liste
template <class T>
void lire_liste_param(ifstream& f, string nom_liste, T* p, int n){
  string aux; 
  for (int i = 0; i<n; i++){
    // on limine les lignes commentes
    bool commentaire = false;
    do {
      getline(f, aux);
      if (aux.substr(0,2) == "//"){
	cout << BoldRed << "Commentaire : " << TextMauve << aux.substr(2) << TextNormal << endl;
	commentaire = true;
      } else {
	commentaire = false;
      }
    }  while (commentaire);
  

    stringstream s; 
    string::size_type ou_ca = aux.find(':', 0);
    if (ou_ca != string::npos)
      s << aux.substr(ou_ca + 1);
    else
      s << aux;
    
    s >> p[i];
    cout << BoldGreen << nom_liste << "[" << i << "] : " << TextCyan << p[i] << TextNormal << endl;
  }
}

// cas o on lit deux listes imbriques
template <class T, class U>
  void lire_liste_param(ifstream& f, string nom_liste1, string nom_liste2, T* p1, U* p2, int n){
  string aux; 
  for (int i = 0; i<n; i++){
    // on limine les lignes commentes
    bool commentaire = false;
    do {
      getline(f, aux);
      if (aux.substr(0,2) == "//"){
	cout << BoldRed << "Commentaire : " << TextMauve << aux.substr(2) << TextNormal << endl;
	commentaire = true;
      } else {
	commentaire = false;
      }
    }  while (commentaire);
  
    stringstream s; 
    string::size_type ou_ca = aux.find(':', 0);
    if (ou_ca != string::npos)
      s << aux.substr(ou_ca + 1);
    else
      s << aux;

    s >> p1[i];
    s >> p2[i];
    cout << BoldGreen << nom_liste1 << "[" << i << "] : " << TextCyan << p1[i] << endl;
    cout << TextGreen << nom_liste2 << "[" << i << "] : " << TextCyan << p2[i] << TextNormal << endl;
  }
}



// afficher l'heure systme
void affiche_heure_systeme(){
  system("date  --rfc-3339=ns");
}

} // end of namespace

#endif
